#!/bin/sh

# This script executes the autorun-fb.sh script provided by imx-test package to confirm framebuffer functionality.

Validate(){
   check_log=$(cat framebuffer_log.txt | grep "Exiting PASS") 
   if [ "$check_log" != "autorun-fb.sh: Exiting PASS" ]; then
      echo "Framebuffer: FAIL"
      exit 1
   fi
}

# Execute unit_tests automated script came with the build.
echo "Observe the result manually on the connected display as per the logs below..."
sh /unit_tests/Display/autorun-fb.sh | tee framebuffer_log.txt
Validate

# Run fbset utility to know the current framebuffer device property.
echo "#############fbset###############"
fbset
if [ $? -eq 0 ]; then
   echo "Framebuffer: PASS"
else
   echo "Framebuffer: FAIL"
fi
