#!/bin/sh

# This script executes the viv_samples,fsl-samples from imx-gpu-viv package provided by NXP to test and confirm the 2D,3D and accelerated graphics demos.

echo "This test case requires an engineer to manually observe the output on screen."

sleep 2

echo "Open VG Test..."
if [ -f /opt/viv_samples/tiger/tiger ]; then
	/opt/viv_samples/tiger/tiger
	echo ""
else
	echo "Open VG test binaries are not present. Kindly check the build"
	echo "Open VG test: FAIL"
	exit 1
fi

echo "Graphics 2D and 3D..."
if [ -f /opt/fsl-samples/g2d/g2d_test ]; then
	/opt/fsl-samples/g2d/g2d_test
	echo ""
else
        echo "Graphics 2D and 3D test binaries are not present. Kindly check the build."
        echo "Graphics 2D and 3D test: FAIL"
fi

echo "Cover Flow"
if [ -f /opt/viv_samples/vdk/cover_flow ]; then
	/opt/viv_samples/vdk/cover_flow &
        sleep 2
        killall cover_flow
else
	echo "Cover Flow test binaries are not present. Kindly check the build."
	echo "Cover Flow test: FAIL"
	exit 1
fi
