#!/bin/sh

HWMONNUM=$1

HWMONDIR=/sys/class/hwmon/hwmon$HWMONNUM/

if [ -z "$HWMONDIR" ] || ! [ -d "$HWMONDIR" ]; then
    echo "Directory $HWMONDIR Not found!\n"
    exit 1
fi

cd $HWMONDIR
NAME=$(cat name)

#Get input prefixes
INPUTS=$(ls -1 *_input | cut -d'_' -f1)
NUMINPUTS=$(echo "$INPUTS" | wc -w)

function get_value(){
    local PREFIX=$1
    local SUFFIX=$2

    FILENAME="${PREFIX}"_"${SUFFIX}"

    VALUE=$(cat "$FILENAME" 2> /dev/null)
    if [[ "$?" != "0" ]]; then
        echo "ERROR"
        exit 1
    else
        echo $VALUE
    fi
}


RETVAL=0

echo ADC: $NAME
echo Number of Inputs: $NUMINPUTS

for i in $INPUTS; do
    if [ -f "${HWMONDIR}/${i}_label" ]; then
        LABEL=$(get_value $i label)
    else
        LABEL=$i
    fi
    VALUE=$(get_value $i input)
    if [[ "$?" != "0" ]]; then RETVAL=1; fi
    echo "    Input $i: $LABEL = $VALUE"
done

exit $RETVAL
