#!/bin/sh

# This script confirms the lm-sensor package binary availability in running target and utilizes lm-sensor binary to test the temperature sensor.

finalResult(){
        if [[ "$output" == *"FAIL"* ]]; then
                echo "Temperature Sensing: FAIL"
                echo $output | tee temp_sensor_error.log
                exit 1
        fi

        tz=$(echo $output | grep "temp.:" | wc -l)

        for (( tzcount = 1; tzcount <= $tz; tzcount++ ))
        do
                temp=$(echo "$output" | grep "temp$tzcount" | cut -d'+' -f2 | cut -d' ' -f1 | cut -d'.' -f1)
                max=$(echo "$output" | grep "temp$tzcount" | cut -d'+' -f3 | cut -d' ' -f1 | cut -d'.' -f1)
                if [[ "$temp" == "" ]] ; then
                        echo "Temperature Sensing: FAIL"
                        exit 1
                elif [ "$output" != "" ] && [ $temp -lt $max ]; then
                continue
                fi
        done

        echo $output | tee temp_sensor.log
        echo "Temperature Sensing: PASS"
        exit 0
}

sensors=$(command -v sensors)

if [ -x $sensors ]; then
        output=$(exec sensors > .output)
        finalResult
else
        echo "sensors command not found. please install lmsensors package"
        echo "Temperature Sensing: FAIL"
        exit 1
fi
