#!/bin/sh
# ssh.sh: SSH support routines

# options to pass to ssh command
SSH_OPTS=

# Check the version of SSH and set correct options
check_ssh_version() {
	local flavor
	flavor=$(ssh -V 2>&1 | cut -d' ' -f1)

	case "$flavor" in
	Dropbear)
		SSH_OPTS="-y"
		;;
	OpenSSH_*)
		SSH_OPTS='-o StrictHostKeyChecking no'
		;;
	*)
		error "$flavor: unknown SSH flavor"
		;;
	esac
}

run_ssh() {
	if [ "$PASSWD" ]; then
		export SSHPASS=$PASSWD
		run sshpass -e ssh "$SSH_OPTS" "$@"
	else
		run ssh "$SSH_OPTS" "$@"
	fi
}

dep_check_programs ssh
[ -z "$PASSWD" ] || dep_check_programs sshpass
check_ssh_version
