#!/bin/sh -e

source "@TSTPLIB@"

load_libraries files mtd/flash

mtd_parse_opts "$@"

ALLOWED_BADBLOCKS=0
if [[ -n "$2" ]]; then
   ALLOWED_BADBLOCKS=$2
fi

mtd_test_start NAND

WRITE_BLOCKS=$(($ERASEBLOCKS-$ALLOWED_BADBLOCKS))

MTD_TEST_INPUT="mtd_test_input_random $ERASESIZE $WRITE_BLOCKS"

nand_test_write() {
	nandwrite $DEVICE $INFILE
}
MTD_TEST_WRITE=nand_test_write

nand_test_read() {
	local READ_SIZE=$((ERASESIZE * WRITE_BLOCKS))
	nanddump $DEVICE -l $READ_SIZE -f $OUTFILE
}
MTD_TEST_READ=nand_test_read

mtd_test_run "Random"
