#!/bin/sh

source "@TSTPLIB@"

# device to be provided as i.e. /dev/rpmsg_ept1.1
device="${1}"

if [ "${1}" == "" ]; then
	echo "please provide the argument, as /dev/rpmsg_ept1.1"
	exit 1
fi

# Checking if the system is using drivers/rpmsg/rpmsg_multiept.c

if [ -e /sys/class/rpmsg/channel_1/ ]; then
	# we are in new eptd driver
	echo "checking for rpmsg channel ..."
	if [ ! -e ${device} ]; then
		echo "creating endpoint ..."
		echo 1 > /sys/class/rpmsg/channel_1/ept_new
		sync
		sleep 1
	fi

	if [ ! -e ${device} ]; then
		echo "error: cannot create endpoint"
		exit 1
	fi

	echo "trying writing to endpoint ..."
	echo -n "a" > "${device}"
	if [ $? == 0 ]; then
		echo "enpoint is writable"
	else
		echo "error: device not writable"
		exit 1
	fi

	echo "trying reading from endpoint ..."
	cat "${device}"
	if [ $? == 0 ]; then
		echo "enpoint is readable"
	else
		echo "error: device not readable"
		exit 1
	fi

	echo "test passed"

	echo "clean up, removing endpoint ..."
	# removing ept or we are stuck in few tests
	echo 1 > /sys/class/rpmsg/channel_1/ept_delete
	sync
	sleep 1

	exit 0
else
	if [ -e /dev/ttyRPMSG0 ]; then
		echo "imx_rpmsg_tty loaded"
	else
		exit 1
	fi
	echo "x20 mount unmount ..."
	for (( i = 0; i < 10; i++ ))
	do
		modprobe imx_rpmsg_tty
		usleep 200000
		modprobe -r imx_rpmsg_tty
		usleep 200000
	done
	echo "test passed"
	exit 0
fi
