#!/bin/sh

source "@TSTPLIB@"

dep_check_programs fbi speaker-test

Help()
{
   echo "Tests HDMI audio"
   echo
   echo "Usage: test_audio-hdmi.sh [OPTION]... "
   echo
   echo "-D     audio device"
   echo "-C     audio card"
   echo "-c     audio channels"
   echo "-f     framebuffer device"
   echo "-i     image file in jpeg/png format"
   echo
}

AUDIO_DEVICE=sysdefault
AUDIO_CARD=PCH
AUDIO_CHANNELS=1
FB_DEVICE=fb0
IMAGE_FILE=timesys_logo.png
ALSA_AUDIO_SAMPLES_DIR="/usr/share/sounds/alsa/"

while getopts ":hD:C:c:f:i:" option; do
   case $option in
	D)
                AUDIO_DEVICE=$OPTARG;;
	C)
                AUDIO_CARD=$OPTARG;;
	c)
                AUDIO_CHANNELS=$OPTARG;;
	f)
                FB_DEVICE=$OPTARG;;
	i)
		IMAGE_FILE=$OPTARG;;
	h)
                Help
                exit;;
	\?)
                echo "Error: Invalid option"
                exit;;
   esac
done

command -v fbi > /dev/null

if [ "$?" = "0" ]; then
	fbi -a -d /dev/$FB_DEVICE $IMAGE_FILE
else
	echo "Wakeup Framebuffer"
	echo 0 > /sys/class/graphics/$FB_DEVICE/blank
fi

if [ -d $ALSA_AUDIO_SAMPLES_DIR ]; then
	speaker-test -D $AUDIO_DEVICE:$AUDIO_CARD -c $AUDIO_CHANNELS -t wav -l 5
else
	speaker-test -D $AUDIO_DEVICE:$AUDIO_CARD -c $AUDIO_CHANNELS -l 5
fi

exit 0
