#!/bin/sh

source "@TSTPLIB@"

dep_check_programs amixer aplay arecord

Help()
{
   echo "Tests audio in"
   echo
   echo "Usage: test_audio-in.sh [OPTION]... "
   echo
   echo "-D     audio device"
   echo "-C     audio card"
   echo "-c     audio channels"
   echo "-a     alsamixer headphones/speaker audio level"
   echo "-m     alsamixer mic level"
   echo "-r     audio record duration"
   echo "-h     print this help and exit"
   echo
}

AUDIO_DEVICE=sysdefault
AUDIO_CARD=PCH
AUDIO_CHANNELS=1
AUDIO_LEVEL=127
MIC_LEVEL=63
RECORD_DURATION=15
AUDIO_FORMAT=dat

while getopts ":hD:C:c:a:m:r:" option; do
   case $option in
	D)
                AUDIO_DEVICE=$OPTARG;;
	C)
                AUDIO_CARD=$OPTARG;;
	c)
                AUDIO_CHANNELS=$OPTARG;;
	a)
		AUDIO_LEVEL=$OPTARG;;
	m)
		MIC_LEVEL=$OPTARG;;
	r)
		RECORD_DURATION=$OPTARG;;
	h)
                Help
                exit;;
	\?)
                echo "Error: Invalid option"
                exit;;
   esac
done

amixer -D $AUDIO_DEVICE -c $AUDIO_CARD sset PCM $AUDIO_LEVEL
amixer -D $AUDIO_DEVICE -c $AUDIO_CARD sset Speaker $AUDIO_LEVEL
amixer -D $AUDIO_DEVICE -c $AUDIO_CARD sset Headphone $AUDIO_LEVEL
amixer -D $AUDIO_DEVICE -c $AUDIO_CARD sset Capture $MIC_LEVEL

arecord -D $AUDIO_DEVICE:$AUDIO_CARD -q -d $RECORD_DURATION -f $AUDIO_FORMAT -c $AUDIO_CHANNELS /tmp/test_audio-in.wav
sleep 2

aplay -vv -D $AUDIO_DEVICE:$AUDIO_CARD -q /tmp/test_audio-in.wav
rm /tmp/test_audio-in.wav

exit 0
