#!/bin/sh

source "@TSTPLIB@"

dep_check_programs amixer speaker-test

Help()
{
   echo "Tests audio out"
   echo
   echo "Usage: test_audio-out.sh [OPTION]... "
   echo
   echo "-D     audio device"
   echo "-C     audio card"
   echo "-c     audio channels"
   echo "-a     alsamixer headphones/speaker audio level"
   echo "-h     print this help and exit"
   echo
}

AUDIO_DEVICE=sysdefault
AUDIO_CARD=PCH
AUDIO_CHANNELS=1
AUDIO_LEVEL=127
ALSA_AUDIO_SAMPLES_DIR="/usr/share/sounds/alsa/"

while getopts ":hD:C:c:a:" option; do
   case $option in
	D)
		AUDIO_DEVICE=$OPTARG;;
	C)
		AUDIO_CARD=$OPTARG;;
	c)
		AUDIO_CHANNELS=$OPTARG;;
	a)
		AUDIO_LEVEL=$OPTARG;;
	h)
		Help
		exit;;
	\?)
		echo "Error: Invalid option"
		exit;;
   esac
done

amixer -D $AUDIO_DEVICE -c $AUDIO_CARD sset PCM $AUDIO_LEVEL
amixer -D $AUDIO_DEVICE -c $AUDIO_CARD sset Speaker $AUDIO_LEVEL
amixer -D $AUDIO_DEVICE -c $AUDIO_CARD sset Headphone $AUDIO_LEVEL

if [ -d $ALSA_AUDIO_SAMPLES_DIR ]; then
	speaker-test -D $AUDIO_DEVICE:$AUDIO_CARD -c $AUDIO_CHANNELS -t wav -l 5
else
	speaker-test -D $AUDIO_DEVICE:$AUDIO_CARD -c $AUDIO_CHANNELS -l 5
fi

exit 0
