#!/bin/sh
# This script reads PMIC regulator attributes using the sysfs interface.

set -e

source "@TSTPLIB@"

REGDIR=/sys/class/regulator
[ -d "$REGDIR" ] || error "$REGDIR: sysfs directory not found"

cd $REGDIR
FileNo=$(ls | wc -l)

check_attr() {
	local dir="$REGDIR/regulator.$1"
	local attr=$2
	local file="$dir/$attr"
	[ ! -e "$file" ] || echo -e "\t$attr: $(cat $file)"
}

check_regulator() {
	local i=$1
	echo "Regulator $i:"
	check_attr $i name
	check_attr $i state
	check_attr $i microvolts
	check_attr $i min_microvolts
	check_attr $i max_microvolts
}

for i in $(seq 0 $((FileNo - 1))); do
	check_regulator $i
done
