#!/bin/sh

source "@TSTPLIB@"

PWMCHIPID=$1
PWMDIR=/sys/class/pwm/pwmchip$PWMCHIPID

PWMPERIOD=1000000
PWMDUDTYCYCLE=500000

echo PWM device $PWMCHIPID:
if [ ! -d $PWMDIR ]; then
	error "The PWM device $ID does not exist"
fi

PWMCHANNELS=$(cat $PWMDIR/npwm)
echo "Number of outputs: $PWMCHANNELS"

RETVAL=0

for i in $(seq 0 $(($PWMCHANNELS - 1))); do
	echo $i > $PWMDIR/export
	if [ $? != 0 ]; then
		RETVAL=1
		echo "  Output $i ERROR: Can't export to the user space."
		continue
	fi

	echo $PWMPERIOD > $PWMDIR/pwm$i/period
	echo $PWMDUDTYCYCLE > $PWMDIR/pwm$i/duty_cycle
	echo 1 > $PWMDIR/pwm$i/enable

	if \
	[ 1 != $(cat $PWMDIR/pwm$i/enable) ]  || \
	[ $PWMPERIOD != $(cat $PWMDIR/pwm$i/period) ] || \
	[ $PWMDUDTYCYCLE != $(cat $PWMDIR/pwm$i/duty_cycle) ]; then
		echo "  Output $i ERROR: Can't set the $i pwm output"
	else
		echo "  Output $i enabled: $PWMDUDTYCYCLE/$PWMPERIOD ns"
	fi

	echo 0 > $PWMDIR/pwm$i/enable
	echo $i > $PWMDIR/unexport
done

exit $RETVAL
