#!/bin/sh

set -e

source "@TSTPLIB@"

# remove cryptodev module
run rmmod cryptodev || true

# list available engines
run openssl engine

######
# baseline

run_openssl() {
	run time -v openssl speed -evp aes-128-cbc -elapsed "$@"
}

# baseline timing
run_openssl

#####
# cryptodev

info "loading cryptodev module..."
run modprobe cryptodev

caam_interrupts() {
	cat /proc/interrupts | grep jr1 | awk '{print $2}'
}

int_start=$(caam_interrupts)

run_openssl -engine cryptodev

int_final=$(caam_interrupts)

[ "$int_start" -ne "$int_final" ] || error "caam was not used by openssl"
