#!/bin/sh

source "@TSTPLIB@"

load_libraries files

dep_check_programs hexdump

# This script takes hexdump of mtd devices based on SPI to confirm its functionality.

dmsg_log=$(dmesg | grep spi)
if [[ "$dmsg_log" != *"MTD device spi"* ]]; then
	echo "boot log doesnt contain any MTD device"
	echo "spi: FAIL"
	exit 1
fi
echo "Checking boot log entry of mtd device...done"

mtdList=$(cat /proc/mtd | grep mtd | cut -d':' -f1)

for dev in $mtdList; do
	info "$dev: dumping device..."
	mktempfile tmpfile
	hexdump -C /dev/$dev > $tmpfile
	if [ ! -s $tmpfile ]; then
		warn "$dev: hexdump data not captured"
		error "spi: FAIL"
	fi
done

echo "spi: PASS"
